import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrTeacherclassroomscheduling {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  TeacherId!: IType<number, bigint>;
  ClassId!: IType<number, bigint>;
  WeekNum!: number;
  SubjectId!: IType<number, bigint>;
  Remark?: string;
  NextTriggerTime?: Date;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrTeacherclassroomschedulingSchema = defineEntity({
  class: IcrTeacherclassroomscheduling,
  comment: '教师课堂排班',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    TeacherId: p.bigint().name('TeacherId').columnType('bigint').comment('教师Id'),
    ClassId: p.bigint().name('ClassId').columnType('bigint').comment('班级Id'),
    WeekNum: p.integer().name('WeekNum').comment('周几'),
    SubjectId: p.bigint().name('SubjectId').columnType('bigint').comment('科目'),
    Remark: p.string().name('Remark').nullable().comment('备注'),
    NextTriggerTime: p.datetime().name('NextTriggerTime').length(3).nullable().comment('下次的触发时间'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
